#include <bsp.h>
#include <stm32f4xx_spi.h>
#include <stm32f4xx_rcc.h>
#include <stm32f4xx_gpio.h>
#include <uart.h>
#include <gpio.h>


#define CODEC_I2C_GPIO_AF              GPIO_AF_I2C1
#define CODEC_I2C_GPIO                 GPIOB
#define CODEC_I2C_SCL_PIN              GPIO_Pin_6
#define CODEC_I2C_SDA_PIN              GPIO_Pin_9
#define CODEC_I2S_SCL_PINSRC           GPIO_PinSource6
#define CODEC_I2S_SDA_PINSRC           GPIO_PinSource9

int main()
{
	GPIO_InitTypeDef GPIO_InitStructure;
 	SPI_InitTypeDef  SPI_InitStructure;
 	uart_t uart1;
 	gpio_t gpio1,gpio2,gpio3,gpio4,BP0;
	bsp_init();
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10 | GPIO_Pin_11; 
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
  	GPIO_Init(GPIOB, &GPIO_InitStructure);     
  	GPIO_PinAFConfig(GPIOB, GPIO_PinSource10, GPIO_AF_USART3);
  	GPIO_PinAFConfig(GPIOB, GPIO_PinSource11, GPIO_AF_USART3);
  	/*GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12; 
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
  	GPIO_Init(GPIOD, &GPIO_InitStructure);     */
  	 
  	gpio1 = gpioopen(0x30C);
  	gpio2 = gpioopen(0x30D);
  	gpio3 = gpioopen(0x30E);
  	gpio4 = gpioopen(0x30F);
  	BP0   = gpioopen(0x00);
  	gpiosetdir(BP0,gpioindir);
  	gpiosetdir(gpio1,gpiooutdir);
  	gpiosetdir(gpio2,gpiooutdir);
  	gpiosetdir(gpio3,gpiooutdir);
  	gpiosetdir(gpio4,gpiooutdir);
  	uartopen(2,&uart1);
  	uart1.cfg = uartparitynone | uart8bits | uartonestop;
  	uart1.speed = 40000;
  	uartsetconfig(&uart1);
  	
	
  	while(1)
  	{
  		gpiosetval(gpio1,gpiogetval(BP0));
  		//if(gpiogetval(BP0))
  			//gpiosetval(gpio1,1);
  		gpioset(gpio2);
  		gpioset(gpio4);
  		gpioclr(gpio3);
  		for(volatile int i=0;i<1024*1024*8;i++);
  		gpiosetval(gpio1,!gpiogetval(BP0));
  		//uartputc(&uart1,0x5A);
  		//gpioclr(gpio1);
  		//if(gpiogetval(BP0))
	  		//gpiosetval(gpio1,0);
  		gpioset(gpio3);
  		gpioclr(gpio2);
  		gpioclr(gpio4);
  		//GPIOD->BSRRL = GPIO_Pin_12;
  		for(volatile int i=0;i<1024*1024;i++);
  		//uartputc(&uart1,0x5A);
    		
    		//GPIOD->BSRRH = GPIO_Pin_12;
  	} 
}
















