/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2011, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@gmail.com
-------------------------------------------------------------------------------*/

#include "LPC17xx.h"
#include <bsp.h>
#include <core.h>
#include <uart.h>
#include <libucstrings.h>
#include <hexviewer.h>
#include <ucdirent.h>
#include <fsexplorer.h>
#define __delay(t) for(volatile int i=0;i<t;i++);




int main (void) 
{
	int CH1,CH2,CH3,CH4,CH5,CH6,CH7,CH8;
	int i = 0;
	char databuff[29]; //3*8 +2*2  [0xa5 0x0f cnt  data   0xf0 0x5a]
	databuff[0]=0xa5;
	databuff[1]=0x0f;
	databuff[2]=0;
	databuff[27]=0xf0;
	databuff[28]=0x5a;
	LEDS_ON;
	libucprintf("Reset the ADC\n\r");
	bsp_ads1278_Synch();
	libucprintf("ADC Reset complete\n\r");
	//remove zeros from ADC
	for(int k=0;k<129;k++)
	{  
	   ads1278sample(&adc0);
	   for(int i=0;i<8;i++)
	   {
	      for(int l=0;l<3;l++)
	        sspgetc(adc0.SSP_device);
	   }
	                                                                                           
	}
	while(1)
	{
		CH1=0;CH2=0;CH3=0;CH4=0;CH5=0;CH6=0;CH7=0;CH8=0;
		ads1278sample(&adc0);
		/*for(int i=0;i<3;i++)
			CH1 = (CH1<<8) + (0xff & (int)sspgetw(adc0.SSP_device));
		for(int i=0;i<3;i++)
			CH2 = (CH2<<8) + (0xff & (int)sspgetw(adc0.SSP_device));
		for(int i=0;i<3;i++)
			CH3 = (CH3<<8) + (0xff & (int)sspgetw(adc0.SSP_device));
		for(int i=0;i<3;i++)
			CH4 = (CH4<<8) + (0xff & (int)sspgetw(adc0.SSP_device));
		for(int i=0;i<3;i++)
			CH5 = (CH5<<8) + (0xff & (int)sspgetw(adc0.SSP_device));
		for(int i=0;i<3;i++)
			CH6 = (CH6<<8) + (0xff & (int)sspgetw(adc0.SSP_device));
		for(int i=0;i<3;i++)
			CH7 = (CH7<<8) + (0xff & (int)sspgetw(adc0.SSP_device));
		for(int i=0;i<3;i++)
			CH8 = (CH8<<8) + (0xff & (int)sspgetw(adc0.SSP_device));*/
		uartputc(UART0,0xa5);
		uartputc(UART0,0x0f);
		uartputc(UART0,databuff[2]++);
		LED1_ON;
		for(int i=0;i<8;i++)
		{
			for(int l=0;l<3;l++)
				uartputc(UART0,sspgetc(adc0.SSP_device));
		}
		uartputc(UART0,0xf0);
		uartputc(UART0,0x5a); 
		
		
		//libucprintf("0%d\t 0%d\t 0%d \n\r ",CH2,CH6,CH7);
		LED1_OFF;
	}
	return 0;
}









